From: Colin Watson <cjwatson@debian.org>
Date: Mon, 17 Feb 2025 18:19:38 +0000
Subject: Port to numpy 2.0

See https://numpy.org/doc/stable/numpy_2_0_migration_guide.html.

Forwarded: https://github.com/cjwatson/mdp-toolkit/pull/new/numpy-2.0
Bug-Debian: https://bugs.debian.org/1095026
Bug-Debian: https://bugs.debian.org/1095356
Last-Update: 2025-02-17
---
 mdp/nodes/em_nodes.py  | 2 +-
 mdp/nodes/lle_nodes.py | 4 ++--
 mdp/test/_tools.py     | 2 +-
 mdp/test/test_hinet.py | 2 +-
 mdp/utils/routines.py  | 2 +-
 5 files changed, 6 insertions(+), 6 deletions(-)

diff --git a/mdp/nodes/em_nodes.py b/mdp/nodes/em_nodes.py
index 2c8d512..cdd3e66 100644
--- a/mdp/nodes/em_nodes.py
+++ b/mdp/nodes/em_nodes.py
@@ -114,7 +114,7 @@ def _stop_training(self):
         if d<=300:
             scale = det(cov_mtx)**(old_div(1.,d))
         else:
-            scale = numx.product(sigma)**(old_div(1.,d))
+            scale = numx.prod(sigma)**(old_div(1.,d))
         if scale <= 0.:
             err = ("The covariance matrix of the data is singular. "
                    "Redundant dimensions need to be removed.")
diff --git a/mdp/nodes/lle_nodes.py b/mdp/nodes/lle_nodes.py
index 54e54eb..36a75f3 100644
--- a/mdp/nodes/lle_nodes.py
+++ b/mdp/nodes/lle_nodes.py
@@ -542,14 +542,14 @@ def _stop_training(self):
 
         if self.svd:
             sig, U = nongeneral_svd(W.T, range=(2, d_out+1))
-            Y = U*numx.sqrt(N)
+            Y = U*numx.sqrt(N, dtype=self.dtype)
         else:
             WW = mult(W, W.T)
             # regularizes the eigenvalues, does not change the eigenvectors:
             W_diag_idx = numx.arange(N)
             WW[W_diag_idx, W_diag_idx] += 0.01
             sig, U = symeig(WW, range=(2, self.output_dim+1), overwrite=True)
-            Y = U*numx.sqrt(N)
+            Y = U*numx.sqrt(N, dtype=self.dtype)
             del WW
         del W
 
diff --git a/mdp/test/_tools.py b/mdp/test/_tools.py
index e8cfedd..fc0b02b 100644
--- a/mdp/test/_tools.py
+++ b/mdp/test/_tools.py
@@ -33,7 +33,7 @@ def assert_array_almost_equal_diff(x,y,digits,err_msg=''):
     msg = '\nArrays are not almost equal'
     assert 0 in [len(numx.shape(x)),len(numx.shape(y))] \
            or (len(numx.shape(x))==len(numx.shape(y)) and \
-               numx.alltrue(numx.equal(numx.shape(x),numx.shape(y)))),\
+               numx.all(numx.equal(numx.shape(x),numx.shape(y)))),\
                msg + ' (shapes %s, %s mismatch):\n\t' \
                % (numx.shape(x),numx.shape(y)) + err_msg
     maxdiff = old_div(max(numx.ravel(abs(x-y))),\
diff --git a/mdp/test/test_hinet.py b/mdp/test/test_hinet.py
index 277948c..6fb1369 100644
--- a/mdp/test/test_hinet.py
+++ b/mdp/test/test_hinet.py
@@ -515,7 +515,7 @@ def test_sfa_net(noisenode):
     flownode = mh.FlowNode(mdp.Flow([noisenode, sfa_node]))
     sfa_layer = mh.CloneLayer(flownode, switchboard.output_channels)
     flow = mdp.Flow([switchboard, sfa_layer])
-    train_gen = numx.cast['f'](numx_rand.random((3, 10, 100 * 100)))
+    train_gen = numx.asarray(numx_rand.random((3, 10, 100 * 100)), dtype='f')
     flow.train([None, train_gen])
 
 
diff --git a/mdp/utils/routines.py b/mdp/utils/routines.py
index fca1f41..17be29f 100644
--- a/mdp/utils/routines.py
+++ b/mdp/utils/routines.py
@@ -293,7 +293,7 @@ def get_dtypes(typecodes_key, _safe=True):
 
 
 _UNSAFE_DTYPES = [numx.dtype(d).type for d in
-                  [numx.half, numx.longfloat, numx.longcomplex]]
+                  [numx.half, numx.longdouble, numx.clongdouble]]
 
 
 def nongeneral_svd(A, range=None, **kwargs):
